#include "BusyWaiting.h"

#include <chrono>
#include <thread>

namespace armarx::skills::provider
{

    BusyWaitingSkill::BusyWaitingSkill() : SimpleSkill(GetSkillDescription())
    {
    }

    SkillDescription
    BusyWaitingSkill::GetSkillDescription()
    {
        return SkillDescription{.skillId = SkillID{.skillName = "BusyWaiting"},
                                .description = "This skill takes two seconds",
                                .rootProfileDefaults = armarx::aron::make_dict(),
                                .timeout = armarx::core::time::Duration::MilliSeconds(10000)};
    }

    Skill::MainResult
    BusyWaitingSkill::main(const MainInput& in)
    {
        for (unsigned int i = 0; i < 10; i++)
        {
            throwIfSkillShouldTerminate();
            std::this_thread::sleep_for(std::chrono::milliseconds(200));
        }

        return {TerminatedSkillStatus::Succeeded, nullptr};
    }
} // namespace armarx::skills::provider
