
#include "Callback.h"

#include "RobotAPI/libraries/aron/core/data/variant/primitive/String.h"

namespace armarx::skills::provider
{
    CallbackSkill::CallbackSkill() : SimpleSkill(GetSkillDescription())
    {
    }

    SkillDescription
    CallbackSkill::GetSkillDescription()
    {
        return SkillDescription{.skillId = skills::SkillID{.skillName = "ShowMeCallbacks"},
                                .description = "This skill does shows callbacks",
                                .rootProfileDefaults = armarx::aron::make_dict(),
                                .timeout = armarx::core::time::Duration::MilliSeconds(1000)};
    }

    Skill::MainResult
    CallbackSkill::main(const MainInput& in)
    {
        ARMARX_IMPORTANT << "Logging three updates via the callback";
        auto up1 = std::make_shared<aron::data::Dict>();
        up1->addElement("updateInfo", std::make_shared<aron::data::String>("Update 1"));

        in.callback(skills::SkillStatus::Running, up1);

        auto up2 = std::make_shared<aron::data::Dict>();
        up2->addElement("updateInfo", std::make_shared<aron::data::String>("Update 2"));
        in.callback(skills::SkillStatus::Running, up2);

        auto up3 = std::make_shared<aron::data::Dict>();
        up3->addElement("updateInfo", std::make_shared<aron::data::String>("Update 3"));
        in.callback(skills::SkillStatus::Running, up3);

        return {TerminatedSkillStatus::Succeeded, nullptr};
    }
} // namespace armarx::skills::provider
