
#include "RandomExitStatus.h"

#include <ArmarXCore/core/logging/Logging.h>

namespace armarx::skills::provider
{
    RandomExitStatus::RandomExitStatus() : SimpleSkill(GetSkillDescription())
    {
    }

    SkillDescription
    RandomExitStatus::GetSkillDescription()
    {
        return SkillDescription{.skillId = skills::SkillID{.skillName = "RandomExitStatus"},
                                .description = "This skill exits with a random status. It either "
                                               "succeeds or fails with a 50/50 chance.",
                                .rootProfileDefaults = armarx::aron::make_dict(),
                                .timeout = armarx::core::time::Duration::MilliSeconds(100)};
    }

    Skill::MainResult
    RandomExitStatus::main(const MainInput& in)
    {
        if ((rand() % 2) != 0)
        {
            return {TerminatedSkillStatus::Succeeded, nullptr};
        }
        return {TerminatedSkillStatus::Failed, nullptr};
    }
} // namespace armarx::skills::provider
