
#include "Segfault.h"

namespace armarx::skills::provider
{
    SegfaultSkill::SegfaultSkill() : SimpleSkill(GetSkillDescription())
    {
    }

    SkillDescription
    SegfaultSkill::GetSkillDescription()
    {
        return SkillDescription{
            .skillId = skills::SkillID{.skillName = "Segfault"},
            .description =
                "This skill segfaults while executing. This will kill (Signal 11) the Provider to "
                "test the stability of the GUI and other components in case of a skill issue.",

            .rootProfileDefaults = armarx::aron::make_dict(),
            .timeout = armarx::core::time::Duration::MilliSeconds(100)};
    }

    Skill::MainResult
    SegfaultSkill::main(const MainInput& in)
    {
        int* number = nullptr;
        (*number)++;

        ARMARX_IMPORTANT << "If you can read this in the log, something is really wrong with the "
                            "SegfaultSkill. It should have segfaulted by now...";
        return {TerminatedSkillStatus::Succeeded, nullptr};
    }
} // namespace armarx::skills::provider
