#pragma once

// RobotAPI
#include <RobotAPI/components/skills/SkillProviderExample/aron/SleepAcceptedType.aron.generated.h>
#include <RobotAPI/libraries/skills/provider/SimpleSpecializedSkill.h>

namespace armarx::skills::provider
{
    // Skills:
    class Sleep : public SimpleSpecializedSkill<armarx::skills::Example::SleepAcceptedType>
    {
    public:
        Sleep();

        static SkillDescription GetSkillDescription();

        void onStopRequested() override;

    private:
        std::atomic_bool aborted = false;
        armarx::Duration timeout;
        Skill::MainResult main(const SpecializedMainInput& in) final;
    };
} // namespace armarx::skills::provider
