
#include "Timeout.h"

namespace armarx::skills::provider
{

    TimeoutSkill::TimeoutSkill() :
        PeriodicSkill(GetSkillDescription(), armarx::core::time::Frequency::Hertz(5))
    {
    }

    SkillDescription
    TimeoutSkill::GetSkillDescription()
    {
        return SkillDescription{.skillId = SkillID{.skillName = "Timeout"},
                                .description = "This fails with timeout reached",
                                .rootProfileDefaults = armarx::aron::make_dict(),
                                .timeout = armarx::core::time::Duration::MilliSeconds(2000)};
    }

    PeriodicSkill::StepResult
    TimeoutSkill::step()
    {
        // do heavy work
        std::this_thread::sleep_for(std::chrono::milliseconds(50));

        return {ActiveOrTerminatedSkillStatus::Running, nullptr};
    }
} // namespace armarx::skills::provider
