

#pragma once

#include <VirtualRobot/VirtualRobot.h>

#include "Writer.h"

namespace armarx::armem::articulated_object
{

    class ArticulatedObjectWriter : virtual public Writer
    {
    public:
        using Writer::Writer;

        /**
         * @brief Stores the articulated object in the memory.
         * 
         */
        bool storeArticulatedObject(const VirtualRobot::RobotPtr& articulatedObject,
                                    const armem::Time& timestamp,
                                    bool isStatic = false);

        /**
         * @brief Stores the articulated object. If the object class in unknown, 
         *        it will also be stored in the corresponding class core segment.
         */
        bool storeArticulatedObjectWithObjectClass(const VirtualRobot::RobotPtr& articulatedObject,
                                                   const armem::Time& timestamp,
                                                   bool isStatic = false);

    private:
    };
} // namespace armarx::armem::articulated_object
