#pragma once

#include <RobotAPI/interface/skills/SkillManagerInterface.h>
#include <RobotAPI/libraries/skills/core/aron/FluxioNode.aron.generated.h>

#include "FluxioNode.h"
#include "FluxioParameter.h"

namespace armarx
{
    namespace skills
    {

        enum class FluxioControlNodeType
        {
            UNKNOWN = 0,
            SPLITTER = 1,
            AND_MERGER = 2,
        };

        struct FluxioControlNode : public FluxioNode
        {
            FluxioControlNodeType controlType;
            std::map<std::string, FluxioParameter> parametersMap;

            std::optional<manager::dto::FluxioNode> toManagerIce() const override;
            std::optional<manager::arondto::FluxioNode> toAron() const override;

            static std::optional<FluxioControlNode>
            FromIce(const manager::dto::FluxioNode& i,
                    std::map<std::string, FluxioProfile>& profilesMap,
                    std::map<std::string, aron::type::ObjectPtr>& typesMap);
            static std::optional<FluxioControlNode>
            FromAron(const manager::arondto::FluxioNode& i,
                     std::map<std::string, FluxioProfile>& profilesMap,
                     std::map<std::string, aron::type::ObjectPtr>& typesMap);
            FluxioControlNodeType FluxioControlNodeTypeFromString(const std::string& type);
            std::optional<std::string>
            FluxioControlNodeTypeToString(const FluxioControlNodeType& type);
        };
    } // namespace skills
} // namespace armarx
