#pragma once

#include <experimental/memory>

#include <RobotAPI/interface/skills/SkillManagerInterface.h>
#include <RobotAPI/libraries/skills/core/aron/FluxioEdge.aron.generated.h>

#include "FluxioNode.h"
#include "FluxioParameter.h"

namespace armarx
{
    namespace skills
    {
        struct FluxioEdge
        {
            std::experimental::observer_ptr<const FluxioNode> fromNodePtr;
            std::experimental::observer_ptr<const FluxioParameter> fromParameterPtr;
            std::experimental::observer_ptr<const FluxioNode> toNodePtr;
            std::experimental::observer_ptr<const FluxioParameter> toParameterPtr;

            bool isValid() const;

            std::optional<manager::dto::FluxioEdge> toManagerIce() const;
            std::optional<manager::arondto::FluxioEdge> toAron() const;

            static std::optional<FluxioEdge>
            FromIce(const manager::dto::FluxioEdge& i,
                    const std::map<const std::string, const std::unique_ptr<FluxioNode>>& nodesMap,
                    const std::map<std::string, FluxioParameter>& parametersMap);
            static std::optional<FluxioEdge>
            FromAron(const manager::arondto::FluxioEdge& i,
                    const std::map<const std::string, const std::unique_ptr<FluxioNode>>& nodesMap,
                    const std::map<std::string, FluxioParameter>& parametersMap);
        };
    } // namespace skills
} // namespace armarx
