#pragma once

#include <experimental/memory>

#include <RobotAPI/interface/skills/SkillManagerInterface.h>

#include "FluxioNode.h"
#include "FluxioParameter.h"

namespace armarx
{
    namespace skills
    {
        struct FluxioParameterNode : public FluxioNode
        {
            std::experimental::observer_ptr<const FluxioParameter> parameterPtr;

            std::optional<manager::dto::FluxioNode> toManagerIce() const override;
            std::optional<manager::arondto::FluxioNode> toAron() const override;

            static std::optional<FluxioParameterNode>
            FromIce(const manager::dto::FluxioNode& i,
                    std::map<std::string, FluxioParameter>& parametersMap);
            static std::optional<FluxioParameterNode>
            FromAron(const manager::arondto::FluxioNode& i,
                    std::map<std::string, FluxioParameter>& parametersMap);
        };
    } // namespace skills
} // namespace armarx
