#pragma once

#include <experimental/memory>
#include <string>

#include <RobotAPI/interface/skills/SkillManagerInterface.h>
#include <RobotAPI/libraries/skills/core/aron/FluxioIdentificator.aron.generated.h>
#include <RobotAPI/libraries/skills/core/aron/FluxioProfile.aron.generated.h>

namespace armarx
{
    namespace skills
    {
        struct FluxioProfile
        {
            std::string id;
            std::string name;
            std::string description = "";
            std::experimental::observer_ptr<const FluxioProfile> parentPtr = nullptr;

            manager::dto::FluxioProfile toManagerIce() const;
            manager::arondto::FluxioProfile toManagerAron() const;
            manager::dto::FluxioIdentificator toFluxioIdentificatorIce() const;
            manager::arondto::FluxioIdentificator toFluxioIdentificatorAron() const;

            static std::experimental::observer_ptr<const FluxioProfile>
            FromFluxioIdentificatorIce(const manager::dto::FluxioIdentificator& i,
                                       std::map<std::string, FluxioProfile>& profilesMap);
            static std::experimental::observer_ptr<const FluxioProfile>
            FromFluxioIdentificatorAron(const manager::arondto::FluxioIdentificator& i,
                                        std::map<std::string, FluxioProfile>& profilesMap);
            static FluxioProfile FromIce(const manager::dto::FluxioProfile& i,
                                         std::map<std::string, FluxioProfile>& profilesMap);
        };
    } // namespace skills
} // namespace armarx
