#pragma once

#include <experimental/memory>
#include <string>

#include "RobotAPI/libraries/aron/core/data/variant/container/Dict.h"
#include <RobotAPI/interface/skills/SkillManagerInterface.h>
#include <RobotAPI/libraries/skills/core/aron/FluxioIdentificator.aron.generated.h>

namespace armarx
{
    namespace skills
    {
        struct FluxioProvider
        {
            std::string id;
            std::string name;

            manager::dto::FluxioProvider toManagerIce() const;
            aron::data::DictPtr toAron() const;
            manager::dto::FluxioIdentificator toFluxioIdentificatorIce() const;
            manager::arondto::FluxioIdentificator toFluxioIdentificatorAron() const;

            static std::experimental::observer_ptr<const FluxioProvider>
            FromFluxioIdentificatorIce(const manager::dto::FluxioIdentificator& i,
                                       std::map<std::string, FluxioProvider>& providersMap);
            static std::experimental::observer_ptr<const FluxioProvider>
            FromFluxioIdentificatorAron(const manager::arondto::FluxioIdentificator& i,
                                        std::map<std::string, FluxioProvider>& providersMap);
            static FluxioProvider FromIce(const manager::dto::FluxioProvider& i);
        };
    } // namespace skills
} // namespace armarx
