#pragma once

#include <experimental/memory>
#include <optional>

#include "RobotAPI/libraries/aron/core/data/variant/container/Dict.h"
#include <RobotAPI/interface/skills/SkillManagerInterface.h>
#include <RobotAPI/libraries/skills/core/aron/FluxioNode.aron.generated.h>

#include "FluxioNode.h"
#include "FluxioSkill.h"

namespace armarx
{
    namespace skills
    {
        struct FluxioSubSkillNode : public FluxioNode
        {
            std::experimental::observer_ptr<const FluxioSkill> skillPtr;

            std::optional<manager::dto::FluxioNode> toManagerIce() const override;
            std::optional<manager::arondto::FluxioNode> toAron() const override;

            static std::optional<FluxioSubSkillNode>
            FromIce(const manager::dto::FluxioNode& i,
                    std::map<std::string, FluxioSkill>& skillsMap);
            static std::optional<FluxioSubSkillNode>
            FromAron(const manager::arondto::FluxioNode& i,
                    std::map<std::string, FluxioSkill>& skillsMap);
        };
    } // namespace skills
} // namespace armarx
