#include "FluxioTypeIdentificator.h"

#include <ArmarXCore/core/logging/Logging.h>

#include <RobotAPI/interface/skills/SkillManagerInterface.h>
#include <RobotAPI/libraries/skills/core/aron/FluxioTypeIdentificator.aron.generated.h>

namespace armarx
{
    namespace skills
    {
        manager::dto::FluxioTypeIdentificator
        FluxioTypeIdentificator::toManagerIce() const
        {
            manager::dto::FluxioTypeIdentificator ret;

            ret.skillId = skillId;
            ret.parameterId = parameterId;

            return ret;
        }

        manager::arondto::FluxioTypeIdentificator
        FluxioTypeIdentificator::toAron() const
        {
            manager::arondto::FluxioTypeIdentificator ret;

            ret.skillId = skillId;
            ret.parameterId = parameterId;

            return ret;
        }

        FluxioTypeIdentificator
        FluxioTypeIdentificator::FromIce(const manager::dto::FluxioTypeIdentificator& i)
        {
            FluxioTypeIdentificator ret;

            ret.skillId = i.skillId;
            ret.parameterId = i.parameterId;

            return ret;
        }

        FluxioTypeIdentificator
        FluxioTypeIdentificator::FromAron(const manager::arondto::FluxioTypeIdentificator& i)
        {
            FluxioTypeIdentificator ret;

            ret.skillId = i.skillId;
            ret.parameterId = i.parameterId;

            return ret;
        }
        
    } // namespace skills
} // namespace armarx
