#pragma once

#include <experimental/memory>
#include <optional>
#include <string>

#include "RobotAPI/libraries/aron/core/data/variant/Variant.h"
#include <RobotAPI/interface/skills/SkillManagerInterface.h>
#include <RobotAPI/libraries/skills/core/aron/FluxioValue.aron.generated.h>

#include "FluxioProfile.h"

namespace armarx
{
    namespace skills
    {
        struct FluxioValue
        {
            std::experimental::observer_ptr<const FluxioProfile> profilePtr;
            armarx::aron::data::VariantPtr content;

            std::optional<manager::dto::FluxioValue> toManagerIce() const;
            std::optional<manager::arondto::FluxioValue> toAron() const;

            static std::optional<FluxioValue>
            FromIce(const manager::dto::FluxioValue& i,
                    std::map<std::string, FluxioProfile>& profilesMap);
            static std::optional<FluxioValue>
            FromAron(const manager::arondto::FluxioValue& i,
                     std::map<std::string, FluxioProfile>& profilesMap);
        };
    } // namespace skills
} // namespace armarx
