#include <string>
#include <vector>

namespace armarx::skills::error
{
    enum class ErrorCode
    {
        ExecutionNotFound,
        ExecutorNotFound,
        RunnerNotFound,
        SkillNotFound,
        SkillDescNotFound,
        NotFluxioCompExecutor,
        ProfileNotFound,
        ProviderNotFound,
        GenericMutexError,
        UserHasNoMutexError,
        AddSkillError,
        ProviderAlreadyExists,
        ConverterError,
        TestError,
        ParameterNotFound,
        ProfileHasNoParent,
        ProfileAlreadyExists,
        MissingRequired
    };

    std::string formatString(const std::string& format, const std::vector<std::string>& args);

    std::string createErrorMessage(ErrorCode code, const std::vector<std::string>& args);

} // namespace armarx::skills::error
