#pragma once

#include <optional>
#include <shared_mutex>
#include <string>

#include "../FluxioSkillStatusUpdate.h"
#include "FluxioExecutor.h"

namespace armarx::skills
{
    class FluxioMergerExecutor : public FluxioExecutor
    {
    public:
        FluxioMergerExecutor(const std::string& id, const std::vector<std::string>& parameterIds);

        void run(std::string executorName,
                 armarx::aron::data::DictPtr parameters,
                 std::experimental::observer_ptr<const FluxioProfile> profilePtr) override;
        void abort() override;
        void checkInToken(const std::string& parameterId);
        std::optional<std::vector<skills::FluxioSkillStatusUpdate>> getStatusUpdate() override;

    private:
        std::map<std::string, bool> tokenHasArrivedMap; // keys are parameterIds
        std::shared_mutex tokenHasArrivedMapMutex;
    };
} // namespace armarx::skills
