#ifndef PROFILEMENUWIDGET_H
#define PROFILEMENUWIDGET_H

#include <QComboBox>
#include <QPushButton>
#include <QWidget>
#include <qpushbutton.h>

#include "../memory/MemoryCommunicatorBase.h"

namespace armarx::skills::gui
{
    class ProfileMenuWidget : public QWidget, public MemoryCommunicatorBase
    {
        Q_OBJECT
    public:
        static const constexpr char* SET_ARGS_BUTTON_TEXT = "Set Params from Clipboard";
        static const constexpr char* COPY_ARGS_BUTTON_TEXT = " Copy Params to Clipboard";
        static const constexpr char* COPY_SKILL_BUTTON_TEXT = " Copy SkillID to Clipboard";
        static const constexpr char* RESET_ARGS_BUTTON_TEXT = " Reset Params to Defaults";
        static const constexpr char* DEFAULT_PROFILE_TEXT = "<No Profile selected. Using root>";
        static const constexpr char* PROFILE_NOT_IMPLEMENTED =
            "Profiles other than the root profile are currently not supported.";
        static const constexpr char* HIST_BUTTON_TEXT = "Load Parameters from Last Execution";
        static const constexpr char* CNGS_BUTTON_TEXT = "Reload lost Parameters";

        // contents are public, as this class is just a convenience wrapper
        QPushButton* setArgsFromClipboard = nullptr;
        QPushButton* copyArgsToClipboard = nullptr;
        QPushButton* copySkillIdToClipboard = nullptr;
        QPushButton* resetArgsToProfile = nullptr;
        QComboBox* profileSelector = nullptr;
        QPushButton* historySelector = nullptr;
        QPushButton* changesSelector = nullptr;

        ProfileMenuWidget(std::shared_ptr<SkillManagerWrapper> _memory, QWidget* parent = nullptr) :
            QWidget(parent), MemoryCommunicatorBase(_memory)
        {
            setupUi();
        }

    public slots:
    
        void updateChangesSelector(const skills::SkillID shownSkill);

    private:
        void setupUi();
    };
} // namespace armarx::skills::gui

#endif // PROFILEMENUWIDGET_H
